import{randomBytes as T,createHash as K}from"crypto";import _ from"base-x";import C from"bad-words-next";import P from"bad-words-next/data/en.json";import N from"bad-words-next/data/es.json";import H from"bad-words-next/data/fr.json";import F from"bad-words-next/data/de.json";var m=class{constructor(e,t){this.status=e,typeof t=="string"?this.body={message:t}:t?this.body=t:this.body={message:`Error: ${e}`}}toString(){return JSON.stringify(this.body)}};function l(n,e){throw(!!1||!1)&&(isNaN(n)||n<400||n>599)?new Error(`HTTP error status codes must be between 400 and 599 \u2014 ${n} is invalid`):new m(n,e)}var J=new TextEncoder;var h=class{constructor(e,t,s,r){this.event=e;this.bucket=t;this.key=s;this.info=r}_name="";_cost=1;_anon=!1;_has="";_any=[];_all=[];SECOND=1;MINUTE=this.SECOND*60;HOUR=this.MINUTE*60;DAY=this.HOUR*24;WEEK=this.DAY*7;anonymous(){return this._anon=!0,this}name(e){return this._name=e,this}cost(e){return e<1&&l(500,"API cost must be at least 1"),this._cost=e,this}has(e){return this._has=e,this}any(e){return this._any=e,this}all(e){return this._all=e,this}async limit(e){if(e.rate<=0)throw"refill rate must be greater than 0";if(e.size<1)throw"refill size must be at least 1";e.size<this._cost&&console.warn(`refill size must be at least equal to cost (${this._cost})`);let{key:t,info:s}=this;if(!this._anon&&!t&&l(401,"Missing API Key"),t&&!this.info&&l(403,"Invalid API Key"),s){if(s.expires&&s.expires.getTime()<Date.now()&&l(403,"API Key Expired"),this._has.length&&!s.permissions.includes(this._has)&&l(403,"Missing Permission: "+this._has),this._all.length&&!this._all.every(i=>s.permissions.includes(i))){let i=this._all.filter(c=>!s.permissions.includes(c)).join(", ");l(403,"Missing Permissions: "+i)}if(this._any.length&&!this._any.some(i=>s.permissions.includes(i))){let i=this._any.join(", ");l(403,"Missing any Permission: "+i)}}let o=(s?.user||this.event.getClientAddress())+":"+this._name,a=await this.bucket.consume(o,e,this._cost);return this.event.setHeaders({"RateLimit-Limit":a.limit.toString(),"RateLimit-Remaining":a.remaining.toString(),"RateLimit-Reset":a.reset.toString(),"RateLimit-Policy":a.policy}),a.allowed||l(429,"Too Many Requests"),a}};var M="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",k=_(M),u=new C;u.add(P);u.add(N);u.add(H);u.add(F);var O=32,B={searchParam:"key",httpHeader:"x-api-key",cookie:"api-key"},x=class{constructor(e,t,s=B){this.storage=e;this.buckets=t;this.options=s}hashFromBytes(e){return K("sha256").update(e).digest("hex")}async generate(e){let t,s;do s=T(this.options.key_length??O),t=k.encode(s);while(u.check(t));let r=this.hashFromBytes(s);return await this.storage.put(r,e),{key:t,hash:r}}async validate(e){if(!e)return null;let t=k.decode(e),s=this.hashFromBytes(t),r=await this.storage.get(s);return r?{hash:s,...r}:null}async remove(e){return await this.storage.del(e)}async retrieve(e){return await this.storage.list(e)}async extract(e){let t=null,s=e.request.clone();return this.options.cookie&&(t=e.cookies.get(this.options.cookie)??null),this.options.httpHeader&&(t=s.headers.get(this.options.httpHeader)||t),this.options.searchParam&&(t=e.url.searchParams.get(this.options.searchParam)||t),this.options.custom&&(t=await this.options.custom(e,t)),t}handle=async e=>{let{event:t,resolve:s}=e,{locals:r}=t,o=await this.extract(t),a=await this.validate(o);return r.api=new h(t,this.buckets,o,a),await s(t)}};var p=class{apply(e,t,s,r){let o=e.size-r,a=Math.floor(r),i=Math.max(t-r,0),c=i>0?Math.ceil(i/e.rate):0,f=`${e.size};w=${e.rate}`;return{allowed:s,limit:o,remaining:a,reset:c,policy:f}}};var w=class extends p{buckets=new Map;async consume(e,t,s=1){let r=Date.now(),o=this.buckets.get(e);o||(o={tokens:t.size,updated:r},this.buckets.set(e,o));let i=(r-o.updated)*t.rate/1e3;o.tokens=Math.min(t.size,o.tokens+i),o.updated=r;let c=o.tokens>=s;return c&&(o.tokens-=s),this.apply(t,s,c,o.tokens)}};import"redis";var b=class n extends p{constructor(t,s="bucket:",r="TokenBucket",o="consume"){super();this.redis=t;this.prefix=s;this.module=r;this.fname=o}async consume(t,s,r=1){let o=await this.redis.sendCommand(["TFCALL",`${this.module}.${this.fname}`,"0",this.prefix+t,s.size.toString(),s.rate.toString(),r.toString()]),a=!1,i=0;for(let c=0;c<o.length;c+=2){let f=o[c],g=o[c+1];switch(f){case"allowed":a=g===1;break;case"tokens":i=parseFloat(g);break}}return this.apply(s,r,a,i)}static async create(t,s="bucket:",r="TokenBucket",o="consume"){let a=`#!js name=${r} api_version=1.0
redis.registerFunction('${o}', (client, key, size, rate, count) => {
	const now = Date.now()

	let bucket = client.call('hgetall', key)
	if (bucket.updated) {
		const deltaMs = now - parseInt(bucket.updated)
		const deltaNo = deltaMs * rate / 1000

		bucket.tokens = Math.min(size, parseFloat(bucket.tokens) + deltaNo)
		bucket.updated = now
	} else {
		bucket = { tokens: size, updated: now }
	}

	const allowed = bucket.tokens >= count
	if (allowed) {
		bucket.tokens -= count
	}

	// calculate how many tokens, or fractions of a token, are needed for the bucket to be full
	const deltaNo = Math.max(size - bucket.tokens, 0)

	// calculate time until the bucket is full, based on refill rate
	const expire = deltaNo > 0 ? Math.ceil(deltaNo / rate) : 0

	client.call('hset', key, 'tokens', bucket.tokens.toString(), 'updated', bucket.updated.toString())
	client.call('expire', key, expire.toString())

	return {
		allowed,
		tokens: bucket.tokens,
	}
})`;return await t.sendCommand(["TFUNCTION","LOAD","REPLACE",a]),new n(t,s,r,o)}};var d=class{constructor(e=1024,t=3600){this.maxSize=e;this.ttl=t*1e3}cache=new Map;ttl;get(e){let t=this.cache.get(e);if(t){let{ts:s,value:r}=t;if(s>Date.now()-this.ttl)return this.cache.delete(e),this.cache.set(e,t),r;this.cache.delete(e)}}set(e,t){return this.cache.size>=this.maxSize&&this.cache.delete(this.cache.keys().next().value),this.cache.set(e,{ts:Date.now(),value:t})}del(e){this.cache.delete(e)}};var v=class{constructor(e,t=1024,s=3600){this.store=e;this.cache=new d(t,s)}cache;async put(e,t){return this.cache.set(e,t),await this.store.put(e,t)}async get(e){return this.cache.get(e)??await this.store.get(e)}async del(e){this.cache.del(e),await this.store.del(e)}async list(e){return this.store.list(e)}};var A={toFirestore:n=>{let{hash:e,...t}=n;return t},fromFirestore:n=>{let e=n.data(),t=e.expires?e.expires.toDate():null;return{hash:n.id,...e,expires:t}}},R=class{constructor(e,t="api"){this.firestore=e;this.name=t;this.collection=this.firestore.collection(this.name).withConverter(A)}collection;async put(e,t){await this.collection.doc(e).set({hash:e,...t})}async get(e){return(await this.collection.doc(e).get()).data()||null}async del(e){await this.collection.doc(e).delete()}async list(e){return(await this.collection.where("user","==",e).get()).docs.map(s=>s.data())}};var E=class{keys=new Map;async put(e,t){this.keys.set(e,t)}async get(e){return this.keys.get(e)??null}async del(e){this.keys.delete(e)}async list(e){return Array.from(this.keys.entries()).filter(([s,r])=>r.user===e).map(([s,r])=>({hash:s,...r}))}};import{ErrorReply as z,SchemaFieldTypes as y}from"redis";var D=class n{constructor(e,t){this.redis=e;this.prefix=t}static async create(e,t="api:"){try{await e.ft.info(t+"index")}catch(s){if(s instanceof z&&s.message==="Unknown index name")await e.ft.create(t+"index",{user:y.TAG,permissions:y.TAG,expires:y.NUMERIC},{ON:"HASH",PREFIX:t});else throw s}return new n(e,t)}async put(e,t){await this.redis.hSet(this.prefix+e,{user:t.user,name:t.name,description:t.description,permissions:t.permissions.join(","),...t.expires?{expires:t.expires.getTime()/1e3}:{}})}async get(e){let t=await this.redis.hGetAll(this.prefix+e);return t.name===null?null:{user:t.user,name:t.name,description:t.description,permissions:t.permissions.split(","),expires:t.expires?new Date(parseFloat(t.expires)*1e3):null}}async del(e){await this.redis.del(this.prefix+e)}async list(e){let t=/[,.?<>{}[\]"':;!@#$%^&()\-+=~|/\\ ]/g,s=e.replace(t,"\\$&");return(await this.redis.ft.search(this.prefix+"index",`@user:{${s}}`)).documents.map(a=>{let i=a.value;return{hash:a.id,user:i.user,name:i.name,description:i.description,permissions:i.permissions.split(","),expires:i.expires?new Date(parseFloat(i.expires)*1e3):null}})}};var De=1,Ie=60,Se=3600,Te=86400,Ke=604800;function _e(n){let t=/(?<rate>\d+)\s*\/\s*(?<unit>second|minute|hour|day|week)\s*(,\s*(?<size>\d+))?/gi.exec(n);if(!t)throw"unable to parse refill value "+n;let s=parseInt(t.groups.rate),r=U(t.groups.unit.toLowerCase()),o=parseInt(t.groups.size??"1");return{rate:s/r,size:o}}function U(n){switch(n){case"second":return 1;case"minute":return 60;case"hour":return 3600;case"day":return 86400;case"week":return 604800;default:throw"unexpected unit"}}export{x as ApiKeys,Te as DAY,R as FirestoreKeyStore,Se as HOUR,E as InMemoryKeyStore,w as InMemoryTokenBucket,v as LruCacheKeyStore,Ie as MINUTE,D as RedisKeyStore,b as RedisTokenBucket,De as SECOND,p as TokenBucket,Ke as WEEK,_e as parseRefill};
